// Copyright 2008-2010  Segher Boessenkool  <segher@kernel.crashing.org>
// Licensed under the terms of the GNU GPL, version 2
// http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt

#include <stdio.h>
//HCF
#include <stdlib.h>
#include <stdarg.h>
//HCF
//#include <sys/stat.h>
//#include <sys/time.h>
#include <xtl.h>
#include <SDL.h>

//HCF
#include <string.h>
/////////#include <SDL_opengl.h>

#include "types.h"
#include "emu.h"
#include "video.h"
#include "audio.h"
#include "render.h"

#include "platform.h"


#define PIXEL_SIZE 2

//HCF
#define VIIMOTE_LIMIT_UP              10000
#define VIIMOTE_LIMIT_DOWN           -10000
#define VIIMOTE_FACTOR_VERY_POSITIVO      77.97   //(22767 / (804-512) )  (77.96...)
#define VIIMOTE_FACTOR_VERY_NEGATIVO      73.44   //(22767 / (511-201) )  (73.441...)
#define VIIMOTE_FACTOR_POSITIVO     112.22   //(32767 / (804-512) )
#define VIIMOTE_FACTOR_NEGATIVO      105.7   //(32767 / (511-201) )
#define VIIMOTE_MEDIO_POSITIVO		   702
#define VIIMOTE_MEDIO_NEGATIVO         303

#define VIIMOTE_MODE_AVERAGE             0
#define VIIMOTE_MODE_ACCURATE            1
#define VIIMOTE_MODE_VERY_ACCURATE       2

//HCF Viimote
u32 viimotex = 0;
u32 viimotey = 0;
u32 viimotez = 0;
short shUseViimote = 0;

static void *rom_file;

//HCF
SDL_Joystick *joystick;
//gamepad stuff
SDL_Joystick *GAMEPAD; //Gamepad
Sint16 joyx, joyy, joyz; //axes
Sint16 blackbutton;
Sint16 whitebutton;
Sint16 abutton; //A button
Sint16 bbutton;
Sint16 xbutton;
Sint16 ybutton;
Sint16 backbutton; //BACK button
Sint16 startbutton; //START button
Sint16 rstick; 
Sint16 dpad; //dpad
Sint16 ltrigger, rtrigger; //Trigger buttons

//HCF This is the accuracy of the viimote
short shViimoteMode = VIIMOTE_MODE_VERY_ACCURATE;
BOOL bInvertAxisX = false;
TTF_Font *font;

void open_rom(const char *path)
{
	rom_file = fopen(path, "rb");
	if (!rom_file)
		fatal("Cannot read ROM file %s\n", path);
}

void read_rom(u32 offset)
{
	u32 n;

	//HCF
	fseek((FILE*)rom_file, 2*(offset + 0x4000), SEEK_SET);
	//fseek(rom_file, 2*(offset + 0x4000), SEEK_SET);

	//HCF
	n = fread(mem + 0x4000, 2, N_MEM - 0x4000, (FILE*)rom_file);
	//n = fread(mem + 0x4000, 2, N_MEM - 0x4000, rom_file);

// gross, but whatever.  one day i'll fix this, but not today
#ifdef _BIG_ENDIAN
	for (u32 i = 0x4000; i < n + 0x4000; i++)
		mem[i] = (mem[i] << 8) | (mem[i] >> 8);
#endif
}


void *open_eeprom(const char *name, u8 *data, u32 len)
{
	char path[256];
	char *home;
	FILE *fp;

	memset(data, 0, len);

	
	
	/*
	strcpy(home,".");
	home = getenv("HOME");
	if (!home)
		fatal("cannot find HOME\n");
	*/
	
	//HCF Cambiar en XBOX a D:
	/*
	snprintf(path, sizeof path, "./.unununium", home);
	mkdir(path, 0777);
	snprintf(path, sizeof path, "./.unununium/%s.eeprom", home, name);
	*/
	//snprintf(path, sizeof path, "./eeproms/%s.eeprom", home, name);
	
	sprintf(path,"D:\\eeproms\\%s.eeprom", name);

	fp = fopen(path, "rb");
	if (fp) {
		fread(data, 1, len, fp);
		if (ferror(fp))
			fatal("error reading EEPROM file %s\n", path);
		fclose(fp);
	}

	fp = fopen(path, "wb");
	if (!fp)
		fatal("cannot open EEPROM file %s\n", path);

	fwrite(data, 1, len, fp);
	fflush(fp);

	return fp;
}

void save_eeprom(void *cookie, u8 *data, u32 len)
{
	//HCF
	FILE *fp = (FILE*)cookie;
	//FILE *fp = cookie;

	rewind(fp);

	fwrite(data, 1, len, fp);
	fflush(fp);
}


static SDL_Surface *sdl_surface;

//HCF ifdef RENDER_soft
static inline u8 x58(u32 x)
{
	x &= 31;
	return (x << 3) | (x >> 2);
}

u32 get_colour(u8 r, u8 g, u8 b)
{
	return SDL_MapRGB(sdl_surface->format, r, g, b);
}

void render_palette(void)
{
	u32 i;
	for (i = 0; i < 256; i++) {
		u16 p = mem[0x2b00 + i];
		palette_rgb[i] = SDL_MapRGB(sdl_surface->format,
		                            x58((p >> 10) & 31),
		                            x58((p >> 5) & 31),
		                            x58(p & 31));
	}
}

void update_screen(void)
{
	if (SDL_MUSTLOCK(sdl_surface))
		if (SDL_LockSurface(sdl_surface) < 0)
			fatal("oh crap\n");

	u32 pitch = sdl_surface->pitch / 4;
	
	//HCF
	u32 *pixels = (u32*)sdl_surface->pixels;
	//u32 *pixels = sdl_surface->pixels;

	u32 x, y, j;
	for (y = 0; y < 240; y++) {
		u32 *p = pixels + PIXEL_SIZE*y*pitch;
		u32 *s = screen + 320*y;

		for (x = 0; x < 320; x++) {
			u32 c = *s++;

			for (j = 0; j < PIXEL_SIZE; j++)
				p[PIXEL_SIZE*x + j] = c;
		}

		for (j = 1; j < PIXEL_SIZE; j++)
			memcpy(p + j*pitch, p, 4*PIXEL_SIZE*320);
	}

	if (SDL_MUSTLOCK(sdl_surface))
		SDL_UnlockSurface(sdl_surface);

	SDL_UpdateRect(sdl_surface, 0, 0, 0, 0);
}
//HCF
//endif

//HCF
/*
ifdef RENDER_gl
void update_screen(void)
{
	SDL_GL_SwapBuffers();
}
endif
*/

u8 button_up;
u8 button_down;
u8 button_left;
u8 button_right;
u8 button_A;
u8 button_B;
u8 button_C;
u8 button_menu;

static char handle_debug_key(int key)
{
	switch (key) {
	case SDLK_ESCAPE:
		return 0x1b;
		//HCF
		/***
	case '0' ... '8':
	case 't':
	case 'y':
	case 'u':
	case 'x':
	case 'q':
	case 'w': case 'e':
	case 'a': case 's': case 'd':
	case 'f':
	case 'v': case 'c':
		****/

	//HCF 
	default:
		return (key);
	}

	return 0;
}

static void handle_controller_key(int key, int down)
{
	switch (key) {
	case SDLK_UP: case 'j':
		button_up = down;
		break;
	case SDLK_DOWN: case 'm':
		button_down = down;
		break;
	case SDLK_LEFT: case 'n':
		button_left = down;
		break;
	case SDLK_RIGHT: case ',':
		button_right = down;
		break;
	case SDLK_SPACE: case 'h':
		button_A = down;
		break;
	case 'b': case 'k':
		button_B = down;
		break;
	case 'g':
		button_C = down;
		break;
	case 'l':
		button_menu = down;
		break;
	}
}

char update_controller(void)
{
	//HCF All
	int retValue = 0;

	SDL_PumpEvents();
	//keys = SDL_GetKeyState(NULL);
	SDL_JoystickUpdate(); //manual refresh of the gamepad(s)
	//parse all gamepads
	
	joyx = SDL_JoystickGetAxis(GAMEPAD, 0);
	joyy = SDL_JoystickGetAxis(GAMEPAD, 3);  //Right thumbstick up and down
	joyz = SDL_JoystickGetAxis(GAMEPAD, 1);
	dpad = SDL_JoystickGetHat(GAMEPAD, 0);
	blackbutton = SDL_JoystickGetButton(GAMEPAD, 4); //Black Button
	whitebutton = SDL_JoystickGetButton(GAMEPAD, 5); //White Button, comprobarlo!!
	abutton = SDL_JoystickGetButton(GAMEPAD, 0); //Get A-Button(0)
	bbutton = SDL_JoystickGetButton(GAMEPAD, 1);
	backbutton = SDL_JoystickGetButton(GAMEPAD, 9); //Get BACK-Button(9)
	rstick = SDL_JoystickGetButton(GAMEPAD,11);
	ltrigger = SDL_JoystickGetButton(GAMEPAD,6);
	rtrigger = SDL_JoystickGetButton(GAMEPAD,7);
	xbutton = SDL_JoystickGetButton(GAMEPAD,2);
	ybutton = SDL_JoystickGetButton(GAMEPAD,3);
	startbutton = SDL_JoystickGetButton(GAMEPAD,8);

	//HCF Quiza en vez de 1 sea CERO!!!
	if(dpad & SDL_HAT_UP)
	{
		button_up = 1;
		retValue = 1;
	}	
	else
	{
		button_up = 0;
	}
	if(dpad & SDL_HAT_DOWN)
	{	
		button_down = 1;
		retValue = 1;
	}
	else
	{
		button_down = 0;
	}
	if(dpad & SDL_HAT_LEFT)
	{	
		button_left = 1;
		retValue = 1;
	}	
	else
	{
		button_left = 0;
	}
	if(dpad & SDL_HAT_RIGHT)
	{	
		button_right = 1;
		retValue = 1;
	}		
	else
	{
		button_right = 0;
	}
	if(abutton)
	{	
		button_A = 1;
		retValue = 1;
	}
	else
	{
		button_A = 0;
	}
	if(bbutton)
	{	
		button_B = 1;
		retValue = 1;
	}
	else
	{
		button_B = 0;
	}
	if(xbutton)
	{	
		button_C = 1;
		retValue = 1;
	}
	else
	{
		button_C = 0;
	}
	if(startbutton)
	{	
		button_menu = 1;
		retValue = 1;
	}
	else
	{
		button_menu = 0;
	}
	if(startbutton && backbutton)
	{
		//Exit to romlist
		XLaunchNewImage( "D:\\default.xbe", NULL);
	}
	else if(backbutton)
	{
		vdXBOptionsMenu();
	}

	if( shUseViimote )
	{
		viimotex = 0;
		viimotey = 0;
		viimotez = 0;

		//HCF: We will not consider movements lower than 10000
		if( shViimoteMode == VIIMOTE_MODE_VERY_ACCURATE )
		{
			//Accurate Viimote
			//HCF The positive values are inverted!!
			if( !bInvertAxisX)
			{
				if (joyx >= VIIMOTE_LIMIT_UP)
				{
					//HCF Invert positive values!!!
					/////viimotex = 512 + (joyx / VIIMOTE_FACTOR_VERY_POSITIVO);
					viimotex = 804 - ((joyx - VIIMOTE_LIMIT_UP) / VIIMOTE_FACTOR_VERY_POSITIVO);
				}
				else if (joyx <= VIIMOTE_LIMIT_DOWN)
				{
					//HCF Add, because the number is already negative!
					//viimotex = 511 + (joyx / VIIMOTE_FACTOR_VERY_NEGATIVO);
					viimotex = 201 - ((joyx - VIIMOTE_LIMIT_DOWN) / VIIMOTE_FACTOR_VERY_NEGATIVO);
				}
			}
			else
			{
				//X axis inverted
				if (joyx >= VIIMOTE_LIMIT_UP)
				{
					//HCF joyx is positive now
					//viimotex = 511 + ((-1 * joyx) / VIIMOTE_FACTOR_VERY_NEGATIVO);
					viimotex = 201 + ((joyx - VIIMOTE_LIMIT_UP) / VIIMOTE_FACTOR_VERY_NEGATIVO);
				}
				else if (joyx <= VIIMOTE_LIMIT_DOWN)
				{
					//HCF The original joyx is negative!
					//HCF Invert positive values!!!
					//viimotex = 512 + ((-1 * joyx) / VIIMOTE_FACTOR_VERY_POSITIVO);
					//viimotex = 804 - ((-1 * joyx) / VIIMOTE_FACTOR_VERY_POSITIVO);
					//viimotex = 804 - ((-1 * (joyx - VIIMOTE_LIMIT_DOWN)) / VIIMOTE_FACTOR_VERY_POSITIVO);
					viimotex = 804 + ( (joyx - VIIMOTE_LIMIT_DOWN) / VIIMOTE_FACTOR_VERY_POSITIVO );
				}
			}

			if (joyy >= VIIMOTE_LIMIT_UP)
			{
				//HCF Invert positive values!!!
				//viimotey = 512 + (joyy / VIIMOTE_FACTOR_VERY_POSITIVO);
				viimotey = 804 - ((joyy - VIIMOTE_LIMIT_UP) / VIIMOTE_FACTOR_VERY_POSITIVO);
			}
			else if (joyy <= VIIMOTE_LIMIT_DOWN)
			{
				//HCF Add, because the number is already negative!
				//viimotey = 511 + (joyy / VIIMOTE_FACTOR_VERY_NEGATIVO);
				viimotey = 201 - ((joyy - VIIMOTE_LIMIT_DOWN) / VIIMOTE_FACTOR_VERY_NEGATIVO);
			}

			if (joyz >= VIIMOTE_LIMIT_UP)
			{
				//HCF Invert positive values!!!
				//viimotez = 512 + (joyz / VIIMOTE_FACTOR_VERY_POSITIVO);
				viimotez = 804 - ((joyz - VIIMOTE_LIMIT_UP) / VIIMOTE_FACTOR_VERY_POSITIVO);
			}
			else if (joyz <= VIIMOTE_LIMIT_DOWN)
			{
				//HCF Add, because the number is already negative!
				//viimotez = 511 + (joyz / VIIMOTE_FACTOR_VERY_NEGATIVO);
				viimotez = 201 - ((joyz - VIIMOTE_LIMIT_DOWN) / VIIMOTE_FACTOR_VERY_NEGATIVO);
			}
		}
		else if( shViimoteMode == VIIMOTE_MODE_ACCURATE )
		{
			//Accurate Viimote
			//HCF The positive values are inverted!!
			if( !bInvertAxisX)
			{
				if (joyx >= VIIMOTE_LIMIT_UP)
				{
					//HCF Invert positive values!!!
					/////viimotex = 512 + (joyx / VIIMOTE_FACTOR_POSITIVO);
					viimotex = 804 - (joyx / VIIMOTE_FACTOR_POSITIVO);
				}
				else if (joyx <= VIIMOTE_LIMIT_DOWN)
				{
					//HCF Add, because the number is already negative!
					//viimotex = 511 + (joyx / VIIMOTE_FACTOR_NEGATIVO);
					viimotex = 201 - (joyx / VIIMOTE_FACTOR_NEGATIVO);
				}
			}
			else
			{
				//X axis inverted
				if (joyx >= VIIMOTE_LIMIT_UP)
				{
					//HCF joyx is positive now
					//viimotex = 511 + ((-1 * joyx) / VIIMOTE_FACTOR_NEGATIVO);
					viimotex = 201 + (joyx / VIIMOTE_FACTOR_NEGATIVO);
				}
				else if (joyx <= VIIMOTE_LIMIT_DOWN)
				{
					//HCF The original joyx is negative!
					//HCF Invert positive values!!!
					//viimotex = 512 + ((-1 * joyx) / VIIMOTE_FACTOR_POSITIVO);
					viimotex = 804 - ((-1 * joyx) / VIIMOTE_FACTOR_POSITIVO);
				}
			}

			if (joyy >= VIIMOTE_LIMIT_UP)
			{
				//HCF Invert positive values!!!
				//viimotey = 512 + (joyy / VIIMOTE_FACTOR_POSITIVO);
				viimotey = 804 - (joyy / VIIMOTE_FACTOR_POSITIVO);
			}
			else if (joyy <= VIIMOTE_LIMIT_DOWN)
			{
				//HCF Add, because the number is already negative!
				//viimotey = 511 + (joyy / VIIMOTE_FACTOR_NEGATIVO);
				viimotey = 201 - (joyy / VIIMOTE_FACTOR_NEGATIVO);
			}

			if (joyz >= VIIMOTE_LIMIT_UP)
			{
				//HCF Invert positive values!!!
				//viimotez = 512 + (joyz / VIIMOTE_FACTOR_POSITIVO);
				viimotez = 804 - (joyz / VIIMOTE_FACTOR_POSITIVO);
			}
			else if (joyz <= VIIMOTE_LIMIT_DOWN)
			{
				//HCF Add, because the number is already negative!
				//viimotez = 511 + (joyz / VIIMOTE_FACTOR_NEGATIVO);
				viimotez = 201 - (joyz / VIIMOTE_FACTOR_NEGATIVO);
			}
			/***********
			//Accurate Viimote
			if( !bInvertAxisX)
			{
				if (joyx > VIIMOTE_LIMIT_UP)
				{
					viimotex = 512 + (joyx / VIIMOTE_FACTOR_POSITIVO);
				}
				else if (joyx < -5000)
				{
					//HCF Add, because the number is already negative!
					//viimotex = 511 + (joyx / VIIMOTE_FACTOR_NEGATIVO);
					viimotex = 201 - (joyx / VIIMOTE_FACTOR_NEGATIVO);
				}
			}
			else
			{
				//X axis inverted
				if (joyx > VIIMOTE_LIMIT_UP)
				{
					//HCF joyx is positive now
					//viimotex = 511 + ((-1 * joyx) / VIIMOTE_FACTOR_NEGATIVO);
					viimotex = 201 + (joyx / VIIMOTE_FACTOR_NEGATIVO);
				}
				else if (joyx < -5000)
				{
					//HCF The original joyx is negative!
					viimotex = 512 + ((-1 * joyx) / VIIMOTE_FACTOR_POSITIVO);
				}
			}

			if (joyy > 5000)
			{
				viimotey = 512 + (joyy / VIIMOTE_FACTOR_POSITIVO);
			}
			else if (joyy < -5000)
			{
				//HCF Add, because the number is already negative!
				//viimotey = 511 + (joyy / VIIMOTE_FACTOR_NEGATIVO);
				viimotey = 201 - (joyy / VIIMOTE_FACTOR_NEGATIVO);
			}

			if (joyz > 5000)
			{
				viimotez = 512 + (joyz / VIIMOTE_FACTOR_POSITIVO);
			}
			else if (joyz < -5000)
			{
				//HCF Add, because the number is already negative!
				//viimotez = 511 + (joyz / VIIMOTE_FACTOR_NEGATIVO);
				viimotez = 201 - (joyz / VIIMOTE_FACTOR_NEGATIVO);
			}
			*********/
		}
		else
		{
			//VIIMOTE_MODE_AVERAGE
			//Viimote takes average values
			if( !bInvertAxisX)
			{
				if (joyx >= VIIMOTE_LIMIT_UP)
				{
					viimotex = VIIMOTE_MEDIO_POSITIVO;
				}
				else if (joyx <= VIIMOTE_LIMIT_DOWN)
				{
					viimotex = VIIMOTE_MEDIO_NEGATIVO;
				}
			}
			else
			{
				//X Axis inverted
				if (joyx >= VIIMOTE_LIMIT_UP)
				{
					viimotex = VIIMOTE_MEDIO_NEGATIVO;
				}
				else if (joyx <= VIIMOTE_LIMIT_DOWN)
				{
					viimotex = VIIMOTE_MEDIO_POSITIVO;
				}
			}
			if (joyy >= VIIMOTE_LIMIT_UP)
			{
				viimotey = VIIMOTE_MEDIO_POSITIVO;
			}
			else if (joyy <= VIIMOTE_LIMIT_DOWN)
			{
				viimotey = VIIMOTE_MEDIO_NEGATIVO;
			}
			if (joyz >= VIIMOTE_LIMIT_UP)
			{
				viimotez = VIIMOTE_MEDIO_POSITIVO;
			}
			else if (joyz <= VIIMOTE_LIMIT_DOWN)
			{
				viimotez = VIIMOTE_MEDIO_NEGATIVO;
			}
		}
	}
	/*****
	SDL_Event event;
	char key;

	while (SDL_PollEvent(&event)) {

		switch (event.type) {
		case SDL_KEYDOWN:
			key = handle_debug_key(event.key.keysym.sym);
			if (key)
				return (key);

			// Fallthrough.
		case SDL_KEYUP:
			handle_controller_key(event.key.keysym.sym,
			                      (event.type == SDL_KEYDOWN));
			break;

		case SDL_QUIT:
			return 0x1b;

		case SDL_ACTIVEEVENT:
		case SDL_MOUSEMOTION:
		case SDL_MOUSEBUTTONDOWN:
		case SDL_MOUSEBUTTONUP:
			continue;

		default:
			//HCF
			//warn("Unknown SDL event type %d\n", event.type);
			continue;
		}
	}
	*******/

	return retValue;
}


u32 get_realtime(void)
{
	
	//HCF SDL_GetTicks returns milliseconds, and we want microseconds
	return (SDL_GetTicks() * 1000);
	
	/*
	struct timeval tv;

	gettimeofday(&tv, 0);
	return 1000000*tv.tv_sec + tv.tv_usec;
	*/
	
}


void warn(const char *format, ...)
{
	va_list ap;
	va_start(ap, format);
	vfprintf(stderr, format, ap);
}

//HCF
//#ifdef USE_DEBUG
void debug(const char *format, ...)
{
	//HCF
	/*
	va_list ap;
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	*/
}
//HCF
//#endif

void fatal(const char *format, ...)
{
	//HCF
	/*
	va_list ap;
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	*/
	
	//HCF
	//exit(1);
}


static void mix( void *cookie, u8 *data, int n)
{
	if (mute_audio) {
		memset(data, 0, n);
		return;
	}

	audio_render((s16 *)data, n/2);
}


void platform_init(void)
{
	//HCF Include joystick
	if (SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO|SDL_INIT_JOYSTICK) < 0)
		fatal("Unable to init SDL: %s\n", SDL_GetError());
	
	//HCF
	SDL_ShowCursor(0);
	
	//HCF
	//atexit(SDL_Quit);

	//HCF
	//SDL_WM_SetCaption("Unununium", 0);

//HCF
//ifdef RENDER_soft
	sdl_surface = SDL_SetVideoMode(PIXEL_SIZE*320, PIXEL_SIZE*240, 0,
	                               SDL_SWSURFACE);

	if (!sdl_surface)
		fatal("Unable to initialise video: %s\n", SDL_GetError());
	if (sdl_surface->format->BytesPerPixel != 4)
		fatal("Didn't get a 32-bit surface\n");

	pixel_mask[0] = sdl_surface->format->Rmask;
	pixel_mask[1] = sdl_surface->format->Gmask;
	pixel_mask[2] = sdl_surface->format->Bmask;
	pixel_shift[0] = sdl_surface->format->Rshift;
	pixel_shift[1] = sdl_surface->format->Gshift;
	pixel_shift[2] = sdl_surface->format->Bshift;

	//HCF For the in-game menu
	TTF_Init();
	//font = TTF_OpenFont( "D:\\tahoma.ttf", 12 );
	font = TTF_OpenFont( "D:\\tahoma.ttf", 14 );
	
	//HCF
	GAMEPAD = SDL_JoystickOpen(0); //Open Pad 1
	SDL_JoystickEventState(SDL_ENABLE); //Enable event stuff for our pad

//HCF
//endif

//HCF
/****
#ifdef RENDER_gl
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
	SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);

	sdl_surface = SDL_SetVideoMode(PIXEL_SIZE*320, PIXEL_SIZE*240, 0, SDL_OPENGL);

	if (!sdl_surface)
		fatal("Unable to initialise video: %s\n", SDL_GetError());
#endif
****/
	render_kill_cache();
	render_init(PIXEL_SIZE);

	//HCF
	SDL_AudioSpec spec, actual;
	
	spec.freq = 44100;
	spec.format = AUDIO_S16SYS;
	spec.channels = 1;
	spec.samples = 1024;
	spec.callback = mix;
	spec.userdata = 0;
	
	/*
	SDL_AudioSpec spec = {
		.freq = 44100,
		.format = AUDIO_S16SYS,
		.channels = 1,
		.samples = 1024,
		.callback = mix,
		.userdata = 0
	}, actual;
	*/
	int ret = SDL_OpenAudio(&spec, &actual);
	debug("ret: %d (%s)\n", ret, SDL_GetError());
debug("--> fr=%d ch=%d sam=%d size=%d sil=x'%04x\n", actual.freq, actual.channels, actual.samples, actual.size, actual.silence);
	SDL_PauseAudio(0);

	// First SDL input does a lot of init, do it now.
	update_controller();
}
void vdXBOptionsMenu()
{
	char cAux = '0';
		
	int iRedibujar = 1;
	int iLongitud;
	int salir = 0;
	int movanterior = MOV_AA;
	int iNumOpciones;
	int iOpcionSeleccionada = 0;

	int iVideoModeChanged = 0;
	
	SDL_Surface *picTexto;
	SDL_Surface *picRectangle;
	SDL_Surface *picRectangleTemp;
	SDL_Rect rectVentana;
	SDL_Rect rectTexto;
	
	char achTexto[100];
	
	SDL_Color textColor = { 255, 255, 255 }; 

	picRectangleTemp = IMG_Load("d:\\rectangle.png");	
			
	SDL_SetColorKey( picRectangleTemp, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(picRectangleTemp->format, 255, 0, 255) );
	picRectangle = SDL_DisplayFormatAlpha(picRectangleTemp);
	SDL_FreeSurface(picRectangleTemp);
	
	/*
	rectVentana.x = (sdl_surface->w - 250) / 2;
	rectVentana.y = 0;
	rectVentana.w = 250;
	rectVentana.h = 200;

	rectTexto.x = rectVentana.x + 30;
	rectTexto.y = 30;
	*/

	
	//rectVentana.x = 50;
	//rectVentana.y = 50;

	rectVentana.x = 160;
	rectVentana.y = 100;
	rectVentana.w = 300;
	rectVentana.h = 220;

	//rectTexto.x = 70;
	//rectTexto.y = 70;
	rectTexto.x = 180;
	rectTexto.y = 120;
		
	iNumOpciones = 2;	
	
	while(!salir)
	{
		update_controller();
		
		if( button_up )
		{
			if( movanterior != MOV_ARRIBA )
			{
				if( iOpcionSeleccionada > 0 )
				{
					iOpcionSeleccionada--;
					iRedibujar = 1;
				}
				
			}
			movanterior = MOV_ARRIBA;
		}
		else if(movanterior == MOV_ARRIBA)
		{
			movanterior = -1;
		}
		
		if( button_down )
		{
			if( movanterior != MOV_ABAJO )
			{
				if( iOpcionSeleccionada < iNumOpciones - 1 )
				{
					iOpcionSeleccionada++;
					iRedibujar = 1;
				}
			}
			movanterior = MOV_ABAJO;
		}
		else if(movanterior == MOV_ABAJO)
		{
			movanterior = -1;
		}	
		
		if( button_A )
		{
			if( movanterior != MOV_AA )
			{
				if( iOpcionSeleccionada == 0 )
				{
					//Viimote
					shViimoteMode = (shViimoteMode + 1) % 3;
					iRedibujar = 1;
				}
				if( iOpcionSeleccionada == 1 )
				{
					//Invert X axis
					if(bInvertAxisX == true)
					{
						bInvertAxisX = false;
					}
					else
					{
						bInvertAxisX = true;
					}

					iRedibujar = 1;
				}
				
			}
			movanterior = MOV_AA;
		}
		else if(movanterior == MOV_AA)
		{
			movanterior = -1;
		}

		if( button_B )
		{
			if( movanterior != MOV_BB )
			{
				if( iOpcionSeleccionada == 0 )
				{
					//Viimote
					if(shViimoteMode > 0)
					{
						shViimoteMode--;
					}
					else
					{
						shViimoteMode = 2;
					}

					iRedibujar = 1;
				}
				if( iOpcionSeleccionada == 1 )
				{
					//Invert X axis
					if(bInvertAxisX == true)
					{
						bInvertAxisX = false;
					}
					else
					{
						bInvertAxisX = true;
					}

					iRedibujar = 1;
				}
			}
			movanterior = MOV_BB;
		}
		else if(movanterior == MOV_BB)
		{
			movanterior = -1;
		}
		
		if( button_menu )
		{
			salir = 1;
		}
			
		if( iRedibujar)
		{
			/**
			rectVentana.x = (sdl_surface->w - 250) / 2;
			rectVentana.y = 0;
			rectVentana.h = 200;
			**/
			//rectVentana.x = 50;
			//rectVentana.y = 50;
			//rectVentana.h = 220;
			rectVentana.x = 160;
			rectVentana.y = 100;
			rectVentana.h = 220;

			SDL_FillRect(sdl_surface, &rectVentana, SDL_MapRGB(sdl_surface->format, 0, 50, 50));

			//TEXTO OPTIONS
			strcpy(achTexto, "VIIMOTE OPTIONS");
			
			//rectTexto.y = 70;
			rectTexto.y = 120;
			picTexto = TTF_RenderText_Solid( font, achTexto, textColor ); 
			SDL_BlitSurface(picTexto, NULL, sdl_surface, &rectTexto);
			SDL_FreeSurface(picTexto);
		
			//TEXTO Viimote value
			switch(shViimoteMode)
			{
				case VIIMOTE_MODE_VERY_ACCURATE:
					strcpy(achTexto, "Viimote: Very Accurate");
					break;
				case VIIMOTE_MODE_ACCURATE:
					strcpy(achTexto, "Viimote: Accurate");
					break;
				case VIIMOTE_MODE_AVERAGE:
					strcpy(achTexto, "Viimote: Average");
					break;
				default:
					strcpy(achTexto, "Viimote: Unknown");
					break;
			}
									
			rectTexto.y = MENU_FIRST_OPTION_Y;
			picTexto = TTF_RenderText_Solid( font, achTexto, textColor ); 
			SDL_BlitSurface(picTexto, NULL, sdl_surface, &rectTexto);
			SDL_FreeSurface(picTexto);

			//TEXTO Invert X axis
			if(bInvertAxisX)
			{
				strcpy(achTexto, "Invert X axis: Yes");
			}
			else
			{
				strcpy(achTexto, "Invert X axis: No");
			}
						
			rectTexto.y = MENU_FIRST_OPTION_Y + MENU_OPTION_HEIGHT;
			picTexto = TTF_RenderText_Solid( font, achTexto, textColor ); 
			SDL_BlitSurface(picTexto, NULL, sdl_surface, &rectTexto);
			SDL_FreeSurface(picTexto);

			//TEXTO INSTRUCTIONS
			strcpy(achTexto, "A/B: Toggle   START: Confirm ");
			rectTexto.y = 200;
			
			picTexto = TTF_RenderText_Solid( font, achTexto, textColor ); 
			SDL_BlitSurface(picTexto, NULL, sdl_surface, &rectTexto);
			SDL_FreeSurface(picTexto);
			
			//RECTANGLE
			switch(iOpcionSeleccionada)
			{
				case 0:
					rectTexto.y = MENU_FIRST_OPTION_Y;
					break;
				case 1:
					rectTexto.y = MENU_FIRST_OPTION_Y + MENU_OPTION_HEIGHT;
					break;
				default:
					rectTexto.y = MENU_FIRST_OPTION_Y;
					break;	
			}
			
			rectTexto.y -= MENU_RECTANGLE_OFFSET_Y;
			rectTexto.x -= MENU_RECTANGLE_OFFSET_X;
			SDL_BlitSurface(picRectangle, NULL, sdl_surface, &rectTexto);
			rectTexto.x += MENU_RECTANGLE_OFFSET_X;
						
			SDL_Flip(sdl_surface);	
		}
		
		iRedibujar = 0;
		
		SDL_Delay(20);
		
	}

	//HCF: Free the memory of the rectangle
	SDL_FreeSurface(picRectangle);
	
}
